
$map
$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 512
$swstack = 128
$framesize = 256


'     +5V <------------
'                      |
'                      |
'             ---------o-----
'     |\     |  |\     |     |
'     |+||---   |+||---      |
'     | ||      | ||         |
'     | ||---   | ||---      |
'     |/     |  |/     |     |
'             ---------o     |                    ATMEGA328
'      Active buzzer   |     |                 --------------
'        TMB09A05      |     |                |     |        |
'                       \|   |                |     |        |
'                        |---|---[ 1k ]---o---|Aref |        |
'                       <|   |            |   |     |      __|
'                      |     |            |   |     |     /
'                      |BC547|            |   |     |____/
'                     ===    |            |   |    /
'                            |            |   |___/
'                            |            |
'        --------------o-----             |
'       |470,0         |BC547             |
'       |+             |                  |
'     =====             \|                |
'     -----   8        |---             |
'       |   ========    <|   |            |
'       |    \____/    |     |            |
'       o----|____|----o     o---[ 1k ]---o---[ 10k]---
'       |              |     |                         |
'       |+              >|   |                         |
'     =====              |---                          |
'     -----             /|                             |
'       |              |                               |
'       |470,0         |BC557                          |
'      ===            ===                             ===



'   ,  - .  .



Dim Dlitelnost_tik As Word                                  ' ""
Dim Period_tik As Dword                                     '  ""
Dim Per_h_tik As Dword                                      '       ""
Dim Per_l_tik As Dword                                      '       ""
Dim Povtor_tik As Word                                      '-       ""

Dim Dlitelnost_tak As Word                                  ' ""
Dim Period_tak As Dword                                     '  ""
Dim Per_h_tak As Dword                                      '       ""
Dim Per_l_tak As Dword                                      '       ""
Dim Povtor_tak As Word                                      '-       ""


Dim I As Word                                               '  - 
Dim Skvajnost_h As Byte                                     '    .  2:1=33%, 3:2=40%; 4:3=43%
Dim Skvajnost_l As Byte                                     '    .




'    .  :   = 1000000/ 

'1- 
Const C1 = 3824                                             '
Const C_1 = 3608                                            '-
Const D1 = 3404                                             '
Const D_1 = 3216                                            '-
Const E1 = 3036                                             '
Const F1 = 2864                                             '
Const F_1 = 2704                                            '-
Const G1 = 2552                                             '
Const G_1 = 2408                                            '-
Const A1 = 2272                                             '
Const A_1 = 2144                                            '-
Const B1 = 2024                                             '

'2- 
Const C2 = 1912                                             '
Const C_2 = 1804                                            '-
Const D2 = 1702                                             '
Const D_2 = 1608                                            '-
Const E2 = 1518                                             '
Const F2 = 1432                                             '
Const F_2 = 1352                                            '-
Const G2 = 1276                                             '
Const G_2 = 1204                                            '-
Const A2 = 1136                                             '
Const A_2 = 1072                                            '-
Const B2 = 1012                                             '

'3- 
Const C3 = 956                                              '
Const C_3 = 902                                             '-
Const D3 = 851                                              '
Const D_3 = 804                                             '-
Const E3 = 759                                              '
Const F3 = 716                                              '
Const F_3 = 676                                             '-
Const G3 = 638                                              '
Const G_3 = 602                                             '-
Const A3 = 568                                              '
Const A_3 = 536                                             '-
Const B3 = 506                                              '


'   ,    
Skvajnost_h = 67                                            '  .  2:1=33%, 3:2=40%; 4:3=43%
Skvajnost_l = 100 - Skvajnost_h
Dlitelnost_tik = 19
Dlitelnost_tak = 15
Period_tik = C1
Period_tak = D1

'    ""
Per_h_tik = Period_tik * Skvajnost_h
Per_h_tik = Per_h_tik / 100
Per_l_tik = Period_tik * Skvajnost_l
Per_l_tik = Per_l_tik / 100
Povtor_tik = Dlitelnost_tik * 1000
Povtor_tik = Povtor_tik / Period_tik
Print Per_h_tik ; " " ; Per_l_tik ; " " ; Povtor_tik        '  ""

'    ""
Per_h_tak = Period_tak * Skvajnost_h
Per_h_tak = Per_h_tak / 100
Per_l_tak = Period_tak * Skvajnost_l
Per_l_tak = Per_l_tak / 100
Povtor_tak = Dlitelnost_tak * 1000
Povtor_tak = Povtor_tak / Period_tak
Print Per_h_tak ; " " ; Per_l_tak ; " " ; Povtor_tak        '  ""


'=====  =====
Do

   For I = 1 To Povtor_tik
      Admux = 71
      Waitus Per_h_tik
      Admux = 7
      Waitus Per_l_tik
   Next I
   Wait 1

   For I = 1 To Povtor_tak
      Admux = 71
      Waitus Per_h_tak
      Admux = 7
      Waitus Per_l_tak
   Next I
   Wait 1

Loop
End
'=====  =====




'   ,         6-  - 120 , 10  .
'For N As Integer = 0 To 119
'  Freq(n) = Round((2 ^ (n / 12)) * 16.35)
'Next

'  
'----------#---------#-----------------#---------#---------#-----

'-----16-----17-----18-----19------21------22------23------24------26------27------29------31---  
'-----33-----35-----37-----39------41------44------46------49------52------55------58------62---  
'-----65-----69-----73-----78------82------87------92------98-----104-----110-----117-----123---  
'----131----139----147----156-----165-----175-----185-----196-----208-----220-----233-----247---  
'----262----277----294----311-----330-----349-----370-----392-----415-----440-----466-----494---  1-
'----523----554----587----622-----659-----698-----740-----784-----831-----880-----932-----988---  2-
'---1046---1109---1175---1244----1318----1397----1480----1568----1661----1760----1864----1975---  3-
'---2093---2217---2349---2489----2637----2794----2960----3136----3322----3520----3729----3951---  4-
'---4186---4434---4698---4978----5274----5587----5919----6271----6644----7039----7458----7901---  5-
'---8371---8869---9396---9955---10547---11174---11839---12543---13288---14079---14916---15803---  6-

'  
'-----16.35-----17.32-----18.35-----19.44------20.60------21.82------23.12------24.50------25.95------27.50------29.13------30.86
'-----32.70-----34.64-----36.70-----38.89------41.20------43.65------46.24------48.99------51.91------54.99------58.26------61.73
'-----65.40-----69.29-----73.41-----77.77------82.40------87.30------92.49------97.99-----103.82-----109.99-----116.53-----123.46
'----130.80----138.58----146.82----155.55-----164.80-----174.60-----184.98-----195.98-----207.63-----219.98-----233.06-----246.92
'----261.60----277.16----293.64----311.10-----329.60-----349.19-----369.96-----391.96-----415.26-----439.96-----466.12-----493.84
'----523.20----554.31----587.27----622.19-----659.19-----698.39-----739.92-----783.91-----830.53-----879.91-----932.24-----987.67
'---1046.40---1108.62---1174.54---1244.39----1318.38----1396.78----1479.83----1567.83----1661.06----1759.83----1864.47----1975.34
'---2092.80---2217.24---2349.09---2488.77----2636.76----2793.55----2959.67----3135.66----3322.11----3519.66----3728.95----3950.68
'---4185.60---4434.49---4698.18---4977.55----5273.53----5587.11----5919.33----6271.31----6644.23----7039.31----7457.89----7901.36
'---8371.20---8868.98---9396.35---9955.09---10547.05---11174.21---11838.66---12542.63---13288.45---14078.62---14915.78---15802.72